<template>
  <div class="dashboard-main">
    <div class="row m-0 dashboard-main-container">
      <div class="col-12 h5 mb-4">ADD</div>

      <b-form @submit.prevent="insertPopup(add)" class="w-100">
        <div class="row m-0 w-100">
          <div class="col-8 col-lg-10 trend-list">
            <b-form-input
              v-model="add"
              required
              placeholder="tracking this keyword"
            >
            </b-form-input>
          </div>
          <div class="col col-lg track-submit">
            <b-button class="w-100 button1" type="submit">TRACK</b-button>
          </div>
        </div>
      </b-form>
    </div>
    <div class="row m-0 dashboard-main-container mt-4">
      <div class="col-12 h5 mb-4">TAG</div>
      <div
        class="col-6 col-md-4 col-xl-3 trend-list"
        v-for="(list, count) in trackingNameGet"
        :key="count"
      >
        <div class="box text-left w-100" @click="removePopup(list.track_name)">
          {{ list.track_name }}
        </div>
      </div>
    </div>
    <div class="row m-0 dashboard-main-container mt-3">
      <div class="col-12 h5 mb-4">FEED</div>
      <div
        class="col-12 col-md-12 col-xl-4 trend-list"
        v-for="(list, count) in trackingFeedGet"
        :key="count"
      >
        <div class="box text-left w-100" v-b-toggle="`collapse-${count}`"
        :class="{ 'bg-blue1': list.sentiment == 'Negative' }">
          <div>
            {{
              list.tokenize
                .split(",")
                .slice(0, 8)
                .join()
                .replace(/,/g, "")
            }}
            <b-collapse :id="`collapse-${count}`">
              <hr />
              <div>
                <a :href="list.linktosource" target="_blank" class="color-white1 font-weight-bold">SOURCE</a><br />
              </div>
              <div>TYPE: {{ list.message_type }}</div>
              <div v-if="list.brand[0]">BRAND: {{ list.brand.join(", ") }}</div>
              <div>TAG: {{ list.message_tag.join(", ") }}</div>
              <div>SENTIMENT: {{ list.sentiment }}</div>
            </b-collapse>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { Action, Getter, namespace } from "vuex-class";

const DashboardStore = namespace("dashboard");
const AuthStore = namespace("auth");

@Component({
  name: "Dashboard_Main"
})
export default class Dashboard_Main extends Vue {
  @DashboardStore.Action("queryTrackingName") queryTrackingName!: any;
  @DashboardStore.Action("queryTrackingFeed") queryTrackingFeed!: any;
  @DashboardStore.Action("removeTracking") removeTracking!: any;
  @DashboardStore.Action("insertTracking") insertTracking!: any;
  @DashboardStore.Getter("trackingNameGet") trackingNameGet!: object;
  @DashboardStore.Getter("trackingFeedGet") trackingFeedGet!: object;
  @AuthStore.Getter("userDataData") userDataData!: string;

  add: string = "";

  mounted() {
    this.getTracking();
  }

  async getTracking() {
    await this.queryTrackingFeed({ brand: this.userDataData });
    await this.queryTrackingName({ role: this.userDataData });
  }

  insertPopup(tag: string) {
    if (!tag) return;
    this.$swal({
      type: "warning",
      title: "Confirm",
      text: "You want to cancel tracking this tag?",
      confirmButtonColor: "#ef476f",
      showCancelButton: true
    }).then(result => {
      if (result.value) {
        this.insertTracking({ track_name: tag, role: this.userDataData }).then(
          resp =>
            this.$swal({
              type: "success",
              title: "Success!",
              text: `Cancel tracking tag name '${tag}'`
            }).then(async () => {
              this.getTracking();
              this.add = "";
            })
        );
      }
    });
  }

  removePopup(tag: string) {
    if (!tag) return;
    this.$swal({
      type: "warning",
      title: "Confirm",
      text: "You want to cancel tracking this tag?",
      confirmButtonColor: "#ef476f",
      showCancelButton: true
    }).then(result => {
      if (result.value) {
        this.removeTracking({ track_name: tag, role: this.userDataData }).then(
          resp =>
            this.$swal({
              type: "success",
              title: "Success!",
              text: `Cancel tracking tag name '${tag}'`
            }).then(async () => this.getTracking())
        );
      }
    });
  }
}
</script>

<style>
</style>
